import xml.etree.ElementTree as ET
import random, string
import uuid
import sys
import copy
import re
tree = ET.parse(sys.argv[1])
root = tree.getroot()
fps = root.get('fps')
rootChildren = list(root.iter('layer'))

# linear halt clamped


def get_id():
    return uuid.uuid4().hex

for child in rootChildren:
    if "outline" in str(child.attrib['type']) and ("_" not in str(child.attrib['desc']) or len(re.findall("-", str(child.attrib['desc']))) >= 1) :
        
        if len(re.findall("-", str(child.attrib['desc']))) == 2:
            anim_times = re.split("-", str(child.attrib['desc']))
            ini = str(anim_times[0])
            end = str(anim_times[1])
            intps = str("clamped")
            intpe = str("clamped")
        elif len(re.findall("-", str(child.attrib['desc']))) == 3:
            anim_times = re.split("-", str(child.attrib['desc']))
            ini = str(anim_times[0])
            end = str(anim_times[1])
            intp = str(anim_times[2])
            if str(intp) == "ease":
                intps = "halt"
                intpe = "halt"
            else:
                intps = str(intp)
                intpe = str(intp)
        elif len(re.findall("-", str(child.attrib['desc']))) == 4:
            anim_times = re.split("-", str(child.attrib['desc']))
            ini = str(anim_times[0])
            end = str(anim_times[1])
            intps = str(anim_times[2])
            intpe = str(anim_times[3])
            if str(intps) == "ease":
                intps = "halt"
            if str(intpe) == "ease":
                intpe = "halt"
        else:
            ini = str(1)
            end = str(3)  
            intps = str("clamped") 
            intpe = str("clamped")           
            
        
        if str(child.attrib['type']) == "outline" : 
            child.attrib['type'] = "advanced_outline"
            for index, item in enumerate(list(child)):
                    if(item.attrib["name"] == "sharp_cusps"):
                        item.remove(list(item)[0])
                        item.attrib["name"] = "cusp_type"
                        integer = ET.SubElement(item, "integer").set("value", "0")
                    if(item.attrib["name"] == "round_tip[0]"):
                        item.remove(list(item)[0])
                        integer = ET.SubElement(item, "integer").set("value", "1")
                        item.attrib["name"] = "start_tip"
                    if(item.attrib["name"] == "round_tip[1]"):
                        item.remove(list(item)[0])
                        ET.SubElement(item, "integer").set("value", "1")
                        item.attrib["name"] = "end_tip"
                    if(item.attrib["name"] == "homogeneous_width"):
                        item.attrib["name"] = "homogeneous"

        child.extend([ET.fromstring("""        <param name="wplist">
          <wplist type="width_point" loop="false">
            <entry>
              <composite guid=\"""" + str(get_id()) + """\" type="width_point">
                <position>
                  <real value="0.0000000000"/>
                </position>
                <width>
                  <real value="1.0000000000"/>
                </width>
                <side_before>
                  <integer value="1"/>
                </side_before>
                <side_after>
                  <integer value="0"/>
                </side_after>
                <lower_bound>
                  <real value="0.0000000000" static="true"/>
                </lower_bound>
                <upper_bound>
                  <real value="1.0000000000" static="true"/>
                </upper_bound>
              </composite>
            </entry>
            <entry>
              <composite guid=\"""" + str(get_id()) + """\" type="width_point">
                <position>
                  <animated type="real">
                    <waypoint time=\"""" + str(int((float(fps) * int(ini)) + 1)) + str("f") + """\" before="constant" after=\"""" + str(intps) + """\">
                      <real guid=\"""" + str(get_id()) + """\" value="0.0000000000"/>
                    </waypoint>
                    <waypoint time=\"""" + end + str("s") + """\" before=\"""" + str(intpe) + """\" after="clamped">
                      <real guid=\"""" + str(get_id()) + """\" value="1.0000000000"/>
                    </waypoint>
                  </animated>
                </position>
                <width>
                  <animated type="real">
                    <waypoint time="0" before="constant" after="constant">
                      <real guid=\"""" + str(get_id()) + """\" value="0.0000000000"/>
                    </waypoint>
                    <waypoint time=\"""" + str(int((float(fps) * int(ini)) + 1)) + str("f") + """\" before="constant" after="clamped">
                      <real guid=\"""" + str(get_id()) + """\" value="1.0000000000"/>
                    </waypoint>
                  </animated>
                </width>
                <side_before>
                  <integer value="0"/>
                </side_before>
                <side_after>
                  <integer value="1"/>
                </side_after>
                <lower_bound>
                  <real value="0.0000000000" static="true"/>
                </lower_bound>
                <upper_bound>
                  <real value="1.0000000000" static="true"/>
                </upper_bound>
              </composite>
            </entry>
          </wplist>
        </param>"""), ET.fromstring("""        <param name="dash_enabled">
          <bool value="false"/>
        </param>"""), ET.fromstring("""        <param name="dilist">
          <dilist type="dash_item" loop="false">
            <entry>
              <composite guid=\"""" + str(get_id()) + """\" type="dash_item">
                <offset>
                  <real value="0.1000000000"/>
                </offset>
                <length>
                  <real value="0.1000000000"/>
                </length>
                <side_before>
                  <integer value="4"/>
                </side_before>
                <side_after>
                  <integer value="4"/>
                </side_after>
              </composite>
            </entry>
          </dilist>
        </param>"""), ET.fromstring("""        <param name="dash_offset">
          <real value="0.0000000000"/>
        </param>""")])

        for bline in child.iter("bline"):
            if "loop" in bline.attrib:
                if bline.attrib["loop"] == "true":
                    bline.set("loop", "false")
                    entry = bline.find("entry")
                    entry_rpt = copy.deepcopy(entry)
                    composite = entry_rpt.find("composite")
                    composite.set("guid", get_id())
                    bline.extend([entry_rpt])

tr2ee = ET.ElementTree(root)
with open(sys.argv[1], "wb") as fh:
    tr2ee.write(fh)
